#include <bits/stdc++.h>
using namespace std;
#define int int64_t
void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    vector<int> p(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> p[i];
    }
    int dp[n + 1][n + 1];
    dp[1][0] = a[1].first;
    int ans = max(int(0), a[1].first);
    int sum = a[1].first;
    for (int i = 2; i <= n; i++) {
        sum += a[i].first;
        ans = max(ans, a[i].first);
    }
    // for (int i = 2; i <= n; i++) {
    //     for (int j = 0; j < i; j++) {
    //         dp[i][j] = dp[i - 1][min(j, i - 2)] + a[i].first + j * a[i].second;
    //         ans = max(ans, dp[i][j]);
    //     }
    //     for (int w = 1; w < i; w++) {
    //         dp[i][w] = max(dp[i][w], dp[i][w - 1]);
    //     }
    // }
    cout << ans;
}
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}